%define distrib Turbolinux
%define nam     pmake
%define ver     2.1.35beta
%define rel     2
%define prefix  /usr


Summary: Berkeley's Parallel Make
Name: %{nam}
Version: %{ver}
Release:  %{rel}
Group: Development/System
License: BSD
Source0: ftp://ftp.icsi.berkeley.edu/pub/ai/stolcke/software/pmake-%{version}.tar.Z
Source1: pmake-sys-alpha.mk
Source2: pmake-sys-i386.mk
Source3: pmake-sys-sparc.mk
Patch0: pmake-2.1.33-glibc.patch
Patch1: pmake-tmpfile.patch
Patch2: pmake-2.1.34-alphalinux.patch
Serial: 2001020901
Distribution: %{distrib}
BuildRoot: /var/tmp/%{name}-%{version}-root
#NoSource: 0


%description
The program make is used to coordinate the compilation and
linking of a set of sources into a program, recompiling
only what is necessary, thus saving a developer a lot of time.
In fact, make can do a lot more - read the info docs.

Pmake is a particular version of make which supports some
additional syntax not in the standard make program.  Some
berkeley programs have Makefiles written for pmake.


%package customs
Summary: A remote execution facility for pmake
Group: Development/Building


%description customs
Customs is a remote execution facility for PMake. Customs is designed to
run on a network of machines with a consistent, shared filesystem. Customs
requires Sun RPC in order to use XDR (eXternal Data Representation) routines
for logging functions.

A single server is designated as the master agent and is additionally
responsible for noting when a machine goes down, from which machines
any given machine will accept jobs and parcelling out available
machines to requesting clients. The job of master is not given to any
one machine but, rather, is decided among the active agents whenever
the previous master dies.

Clients are provided to:
	- alter the availability criteria for the local machine (importquota)
	- find the status of all registered hosts on the net (reginfo).
	- abort, restart or ping any customs agent on the network (cctrl).
	- export a command from the shell (export).
	- accept log information from all hosts on the net (logd).



%changelog
* Fri Feb 9 2001 Hirofumi Takeda <takepin@turbolinux.co.jp>                  
- turn off setuid root (#1463)

* Fri Sep 22 2000 Hirofumi Takeda <takepin@turbolinux.co.jp>                  
- rewrite spec file for FHS 2.1                                              
- 2.1.35beta

* Thu Jul 28 2000 SL Baur  <steve@turbolinux.co.jp>
- fix for non-ix86 builds

* Wed Feb 09 2000 Takeshi Aihana <aihana@turbolinux.co.jp>
- Rebuild for TurboLinux Workstation 6.0J

* Mon Jan 24 2000 KC M <kcm@turbolinux.co.jp>
- fix tmp file security problem
- ftp://ftp.freebsd.org/pub/FreeBSD/CERT/patches/SA-00:01/make.patch

* Mon Jan 24 2000 KC M <kcm@turbolinux.co.jp>
- 2.1.33

* Wed Oct 28 1998 Scott Stone <sstone@turbolinux.com>
- Changed egcs refs to 'gcc', since 'gcc' == egcs on TL
- Built for TL 3.0

* Mon Aug 17 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Fri May 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Dec 16 1997 Otto Hammersmith <otto@redhat.com>
- fixed bug related to rules to build .a files.

* Thu Oct 23 1997 Cristian Gafton <gafton@redhat.com>
- updated spec file

* Mon Jul 21 1997 Erik Troan <ewt@redhat.com>
- built against glibc


%prep
rm -rf $RPM_BUILD_ROOT


%setup -q -n pmake
%patch0 -p1 -b .glibc
%patch1 -p1 -b .tmpfile
%patch2 -p1

chmod +w $RPM_BUILD_DIR/pmake/lib/mk/*.mk
%ifarch i386 i465 i586 i686
cp $RPM_SOURCE_DIR/pmake-sys-i386.mk $RPM_BUILD_DIR/pmake/lib/mk/sys-i386.mk
cp $RPM_SOURCE_DIR/pmake-sys-i386.mk $RPM_BUILD_DIR/pmake/lib/mk/sys-i486.mk
cp $RPM_SOURCE_DIR/pmake-sys-i386.mk $RPM_BUILD_DIR/pmake/lib/mk/sys-i586.mk
cp $RPM_SOURCE_DIR/pmake-sys-i386.mk $RPM_BUILD_DIR/pmake/lib/mk/sys-i686.mk
%else
cp $RPM_SOURCE_DIR/pmake-sys-${RPM_ARCH}.mk $RPM_BUILD_DIR/pmake/lib/mk/sys-`uname -m`.mk
%endif


%build
#
# Bootstrap build of local pmake with makefile's
mkdir bin
make	CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
	BINDIR=`pwd`/bin LIBDIR=`pwd`/lib/pmake
make	CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
	BINDIR=`pwd`/bin LIBDIR=`pwd`/lib/pmake install

#
# Then build pmake using pmake & Makefile's
`pwd`/bin/pmake CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" all


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/bin
mkdir -p $RPM_BUILD_ROOT%{prefix}/include
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib
mkdir -p $RPM_BUILD_ROOT%{_mandir}
mkdir -p $RPM_BUILD_ROOT%{prefix}/sbin

`pwd`/bin/pmake CC="gcc $RPM_OPT_FLAGS" SYSFLAGS="-DSYSV -DSVR4" \
	DESTDIR=$RPM_BUILD_ROOT MANDIR=%{prefix}/share/man install
# that didn't work when I tried it, use brute force
if [ -d $RPM_BUILD_ROOT%{prefix}/man ]; then
	mv $RPM_BUILD_ROOT%{prefix}/man/* $RPM_BUILD_ROOT%{prefix}/share/man
fi

# allow for a restartable build
if [ ! -f customs/README.customs ]; then
	mv -f customs/README customs/README.customs
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%attr(755,root,root) %{prefix}/bin/pmake
%{prefix}/bin/vmake
%{_mandir}/man1/pmake.1*
%{prefix}/lib/pmake
%doc CHANGES INSTALL README customs/README.customs etc tests
%doc doc/tutorial.* doc/prefix.*

%files customs
%defattr(-,root,root)
%{prefix}/bin/reginfo
%attr(755,root,root) %{prefix}/bin/export
%{prefix}/bin/rexport
%{prefix}/sbin/importquota
%{prefix}/sbin/cctrl
%{prefix}/sbin/logd
%{prefix}/sbin/customs

%{_mandir}/man1/reginfo.1*
%{_mandir}/man1/export.1*
%{_mandir}/man1/rexport.1*
%{_mandir}/man8/customs.8*
%{_mandir}/man8/cctrl.8*
%{_mandir}/man8/importquota.8*
%{_mandir}/man8/logd.8*

%{prefix}/lib/libcustoms*
%{prefix}/include/customs
